searchNodes=[{"doc":"Symbolic Math for Elixir, with Units support","ref":"Exun.html","title":"Exun","type":"module"},{"doc":"Eval an ast (not text expression)","ref":"Exun.html#ast_eval/2","title":"Exun.ast_eval/2","type":"function"},{"doc":"Parse and evaluate an expression. If ast is true returns de AST tuple, if it is false return a human-readable (and parseable) expression. iex&gt; Exun.eval &quot;x[m^2]+4[cm^2]&quot;,%{&quot;x&quot;=&gt;&quot;3&quot;} &quot;3.0004[m^2]&quot;","ref":"Exun.html#eval/2","title":"Exun.eval/2","type":"function"},{"doc":"Same as eval but returns AST","ref":"Exun.html#eval_ast/2","title":"Exun.eval_ast/2","type":"function"},{"doc":"Parse a math expression, not a 'equality', with context definitions For example, express 'x' squared meters, and then define x to be 3. iex&gt; Exun.parse( &quot;x[m^2]&quot;, %{&quot;x&quot;=&gt;&quot;3&quot;}) {{:unit, {:vari, &quot;x&quot;}, {:elev, {:vari, &quot;m&quot;}, {:numb, 2}}}, %{{:vari, &quot;x&quot;} =&gt; {:numb, 3}}} returns a tuple {expression, parsed_context} where expression is a tuple that holds math AST and parsed_context is a map whith all equalities (definitions) parsed as &quot;name&quot; =&gt; expression See parse_txt for an explanation","ref":"Exun.html#parse/2","title":"Exun.parse/2","type":"function"},{"doc":"Parses an expression in text format. Special symbols used:An Unit: &lt;number&gt;[UnitExpression] : 1[m/s]A multiplication, division, suma, rest and parenthesis works in the usual way: 2x-3(y-2)Function call: fname(args): sin(x)A derivate: &lt;expression&gt;'&lt;var&gt; : sin(x)'x. Symbol (') has the greatest priority, for example y^x'x is equals to y^(x'x). Use () to be clear: (y^x)'xAn integral: $&lt;expression&gt;,&lt;var&gt;: $tan(x),xYou can sum units: 1[m]+1[cm] if are of the same magnitude. For example 1[m]+1[s] will throw an exception. You can multiple/divide any two unis.","ref":"Exun.html#parse_text/1","title":"Exun.parse_text/1","type":"function"},{"doc":"Replace definitions in ParsedContext (pc) in tree","ref":"Exun.html#replace/2","title":"Exun.replace/2","type":"function"},{"doc":"Collect Math expression, try to simplify","ref":"Exun.Collect.html","title":"Exun.Collect","type":"module"},{"doc":"Main collecting function. Try to simplify tree withou chaging its value Gets and returns an AST, as produced by Exun.parse.","ref":"Exun.Collect.html#coll/1","title":"Exun.Collect.coll/1","type":"function"},{"doc":"Expand mult(sum) to try collect more","ref":"Exun.Collect.html#expand/1","title":"Exun.Collect.expand/1","type":"function"},{"doc":"Check cyclic definitions in context","ref":"Exun.Cyclic.html","title":"Exun.Cyclic","type":"module"},{"doc":"Get a list of variables down a tree, checking cyclic definition from 'context' user defs. Check cyclic definitions in 'context', a map that holds values like %{&quot;f&quot; =&gt; &quot;x^2+2*x+3&quot;}. If you pass a cyclic map this function detects it, for example:%{&quot;a&quot;=&gt;&quot;b&quot;, &quot;b&quot;=&gt;&quot;c&quot;, &quot;c&quot;=&gt;&quot;a&quot;}","ref":"Exun.Cyclic.html#check/1","title":"Exun.Cyclic.check/1","type":"function"},{"doc":"Derivate expressions","ref":"Exun.Der.html","title":"Exun.Der","type":"module"},{"doc":"Derive function for variable x, may be an ast or an expresion in text modederiv(&quot;sin(x)&quot;,&quot;x&quot;) -&gt; cos(x)*x&#39;x Or an AST, for internal use of libraryderiv({:vari,&quot;x&quot;},&quot;x&quot;) -&gt; {:numb,1}","ref":"Exun.Der.html#deriv/2","title":"Exun.Der.deriv/2","type":"function"},{"doc":"Compares two expressions","ref":"Exun.Eq.html","title":"Exun.Eq","type":"module"},{"doc":"Tree equality, normalize compounds '' and '+' because {,{,1,2},{,3,4}} == {,{,1,3},{,2,4}} so transform both trees to {{:m,}[1,2,3,4]} before compare","ref":"Exun.Eq.html#eq/2","title":"Exun.Eq.eq/2","type":"function"},{"doc":"Sort for m multiple list Sorts components of lis {{:m,op},lst} in a convenient way for eq and operating","ref":"Exun.Eq.html#smm/2","title":"Exun.Eq.smm/2","type":"function"},{"doc":"Function management. @base and @compound are the definitions of external functions.","ref":"Exun.Fun.html","title":"Exun.Fun","type":"module"},{"doc":"base is a map that holds functions names and a tupla For example:&quot;ln(F)&quot; =&gt; {&amp;:math.log/1, &quot;F&#39;x/F&quot;, &quot;x*ln(F)-$(x/F),x&quot;}ln(F) : means function name is 'ln' and can receive Functions as argument&amp;:math.log/1 : Is the Elixir numeric function for lnF'x/F : is the symbolic derivative of ln, deriv(F,x)/Fx*ln(F)-$(x/F),x : is the symbolic integral for lnFor now the definitions are&quot;ln(F)&quot; =&gt; {&amp;:math.log/1, &quot;F&#39;x/F&quot;, &quot;x*ln(F)-$(x/F),x&quot;}, &quot;sin(F)&quot; =&gt; {&amp;:math.sin/1, &quot;F&#39;x*cos(F)&quot;, nil}, &quot;cos(F)&quot; =&gt; {&amp;:math.cos/1, &quot;-F&#39;x*sin(F)&quot;, nil}, &quot;tan(F)&quot; =&gt; {&amp;:math.tan/1, &quot;F&#39;x/cos(F)^2&quot;, nil}, &quot;acos(F)&quot; =&gt; {&amp;:math.acos/1, &quot;-F&#39;x/(1-F^2)^0.5&quot;, nil}, &quot;asin(F)&quot; =&gt; {&amp;:math.asin/1, &quot;F&#39;x/(1-F^2)^0.5&quot;, nil}, &quot;atan(F)&quot; =&gt; {&amp;:math.atan/1, &quot;F&#39;x/(1+F^2)&quot;, nil}, &quot;sinh(F)&quot; =&gt; {&amp;:math.sinh/1, &quot;F&#39;x*cosh(F)&quot;, nil}, &quot;cosh(F)&quot; =&gt; {&amp;:math.cosh/1, &quot;F&#39;x*sinh(F)&quot;, nil}, &quot;tanh(F)&quot; =&gt; {&amp;:math.tanh/1, &quot;F&#39;x/cosh(F)^2&quot;, nil}, &quot;asinh(F)&quot; =&gt; {&amp;:math.asinh/1, &quot;F&#39;x/(F^2+1)^0.5&quot;, nil}, &quot;acosh(F)&quot; =&gt; {&amp;:math.acosh/1, &quot;F&#39;x/(F^2-1)^0.5&quot;, nil}, &quot;atanh(F)&quot; =&gt; {&amp;:math.atanh/1, &quot;F&#39;x/(1-F^2)&quot;, nil}","ref":"Exun.Fun.html#base/0","title":"Exun.Fun.base/0","type":"function"},{"doc":"Compounds is a map that holds synthetic definitions. Function revert_compounds is able to look in an ast and identify this list, substituting the values. For now, the definitions are:&quot;sqrt(F)&quot; =&gt; &quot;F^0.5&quot;, &quot;tan(F)&quot; =&gt; &quot;sin(F)/cos(F)&quot;","ref":"Exun.Fun.html#compounds/0","title":"Exun.Fun.compounds/0","type":"function"},{"doc":"returns true if ast contains variable vc","ref":"Exun.Fun.html#contains/2","title":"Exun.Fun.contains/2","type":"function"},{"doc":"For convenience, creates ast {{:m,:mult},[a,b^-1]}","ref":"Exun.Fun.html#divi/2","title":"Exun.Fun.divi/2","type":"function"},{"doc":"For convenience, creates ast {:elev,a,b}","ref":"Exun.Fun.html#elev/2","title":"Exun.Fun.elev/2","type":"function"},{"doc":"Finds and exec a function call. Search in base and compounds, if cannot find any returns a symbolic fcall.","ref":"Exun.Fun.html#fcall/2","title":"Exun.Fun.fcall/2","type":"function"},{"doc":"returns true if ast is a polynomial element on v","ref":"Exun.Fun.html#is_poly/2","title":"Exun.Fun.is_poly/2","type":"function"},{"doc":"For convenience, creates ast {{:m,:mult},[a,b]}","ref":"Exun.Fun.html#mult/2","title":"Exun.Fun.mult/2","type":"function"},{"doc":"Replace arguments on ast as specified. Not intended for external use, mus be public for now","ref":"Exun.Fun.html#replace_args_internal/3","title":"Exun.Fun.replace_args_internal/3","type":"function"},{"doc":"For convenience, creates ast {{:m,:mult},[a,-b]}","ref":"Exun.Fun.html#rest/2","title":"Exun.Fun.rest/2","type":"function"},{"doc":"Looks in compounds for a match of ast and return it. Thw first wins.","ref":"Exun.Fun.html#revert_compounds/1","title":"Exun.Fun.revert_compounds/1","type":"function"},{"doc":"For convenience, creates ast {{:m,:suma},[a,b]}","ref":"Exun.Fun.html#suma/2","title":"Exun.Fun.suma/2","type":"function"},{"doc":"Try to integrate function","ref":"Exun.Integral.html","title":"Exun.Integral","type":"module"},{"doc":"Integrate function for var v. Expect an AST and return an AST.","ref":"Exun.Integral.html#integ/2","title":"Exun.Integral.integ/2","type":"function"},{"doc":"","ref":"Exun.Integral.html#integ_parts/2","title":"Exun.Integral.integ_parts/2","type":"function"},{"doc":"","ref":"Exun.Integral.html#integ_poly/2","title":"Exun.Integral.integ_poly/2","type":"function"},{"doc":"","ref":"Exun.Integral.html#integ_udu/2","title":"Exun.Integral.integ_udu/2","type":"function"},{"doc":"Change type operation 'from' to another type 'to' in an ast. Not used for now, try to not perform optimization on tuple {:integral} to avoid recursion, but for now I will approach this problem on a more elegant way (Pattern matching). Leave this code for future needs","ref":"Exun.Integral.html#mutate/3","title":"Exun.Integral.mutate/3","type":"function"},{"doc":"","ref":"Exun.Integral.html#symbinteg/1","title":"Exun.Integral.symbinteg/1","type":"function"},{"doc":"Exun is intense in tuple management and recursion. This module is a try to buil tuple's element in parallel using Task. The macro mp is responsible for that.","ref":"Exun.MProc.html","title":"Exun.MProc","type":"module"},{"doc":"","ref":"Exun.MProc.html#mp/1","title":"Exun.MProc.mp/1","type":"macro"},{"doc":"Build tuple in async mode, so every element of the tuple is spawned in its own process. Only for tuple sizes greater than 2For example::timer.tc(fn -&gt; {:timer.sleep(1000), :timer.sleep(1000), :timer.sleep(1000)} end) {3002269, {:ok, :ok, :ok}}:timer.tc(fn -&gt; mp {:timer.sleep(1000), :timer.sleep(1000), :timer.sleep(1000)} end) {1001001, {:ok, :ok, :ok}}","ref":"Exun.MProc.html#parallel/2","title":"Exun.MProc.parallel/2","type":"macro"},{"doc":"Simple transformation of a tree","ref":"Exun.Math.html","title":"Exun.Math","type":"module"},{"doc":"Change power sign of AST (expon * -1 or 1/tree)","ref":"Exun.Math.html#chpow/1","title":"Exun.Math.chpow/1","type":"function"},{"doc":"Change sign of AST","ref":"Exun.Math.html#chsign/1","title":"Exun.Math.chsign/1","type":"function"},{"doc":"Match ASTs. Functions umatch and match try to match patter with a real expression. Rules for matching, by example:umatch &quot;f&quot;, &quot;(any valid expression)&quot; Will always match f =&gt; expressionEx: umatch &quot;f&quot;,&quot;x^2+y&quot;umatch &quot;f'x&quot;, &quot;exp&quot;Match f'x as exp AND f as $exp,xEx: umatch &quot;f'x&quot;, &quot;-cos(x)&quot;umatch &quot;f&lt;op&gt;g&quot;, &quot;exp&quot;Will tray to match f and g against exp using &lt;op&gt;=*,+,-,/,^ on any possible combinationEx: umatch &quot;a+b&quot;, &quot;2**x^2+3&quot;umatch &quot;f**f'x&quot;, &quot;exp&quot;Will match if can find a product on exp of the form f ** d(f)/dxEx: umatch &quot;sin(x)*cos(x)&quot;umatch &quot;f**$f,x&quot;Will match if can find a product on exp of the form f ** integ(f,x)umatch &quot;f(x,y)&quot;, &quot;exp&quot;Will match if exp is a function call and can match x and y with its arguments.Ex: umatch &quot;f(a,b)&quot;, &quot;function(2**x,y^3)&quot;umatch &quot;uv'x&quot;,&quot;sin(x)*cos(x)&quot;, [&quot;vu'x&quot;]Will match u and v against &quot;sin(x)cos(x)&quot; and checks that condition &quot;vu'x&quot; does not contains a symbolic integral. This case is used for integrate by parts: $uv'x,x = uv - $v**u'x,x","ref":"Exun.Pattern.html","title":"Exun.Pattern","type":"module"},{"doc":"","ref":"Exun.Pattern.html#allones?/1","title":"Exun.Pattern.allones?/1","type":"function"},{"doc":"TODO: External testing, function roottype returns an atom with the type of the root tuple of expression. If you want to check if an expression is a symbolic integral, roottype(expr) must not be :integ For now, it returns true if there is not :integ inside ast","ref":"Exun.Pattern.html#check_conds/2","title":"Exun.Pattern.check_conds/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#checkmap/3","title":"Exun.Pattern.checkmap/3","type":"function"},{"doc":"Get any combination from list that supports ssets spec","ref":"Exun.Pattern.html#combin/2","title":"Exun.Pattern.combin/2","type":"function"},{"doc":"Get n sets (size of abstract list) from a list of m size (expression) this produces a quasy cartesian product for all combinations between right and left lists. For example, if left and right has the same size n, we will try all possible combinations one to one. If ther is more elements on right list then we also must handle partitions (tuples) and order inside... a mess you know iex(1)&gt; Exun.Pattern.combin_expand {{:m,:mult},[1,2,3]},{{:m,:mult},[&quot;a&quot;,&quot;b&quot;,&quot;c&quot;]} [ [&quot;a&quot;, &quot;b&quot;, &quot;c&quot;], [&quot;a&quot;, &quot;c&quot;, &quot;b&quot;], [&quot;b&quot;, &quot;a&quot;, &quot;c&quot;], [&quot;b&quot;, &quot;c&quot;, &quot;a&quot;], [&quot;c&quot;, &quot;a&quot;, &quot;b&quot;], [&quot;c&quot;, &quot;b&quot;, &quot;a&quot;] ] iex(2)&gt; Exun.Pattern.combin_expand {{:m,:mult},[1,2]},{{:m,:mult},[&quot;a&quot;,&quot;b&quot;,&quot;c&quot;]} [ [&quot;a&quot;, {&quot;b&quot;, &quot;c&quot;}], [{&quot;b&quot;, &quot;c&quot;}, &quot;a&quot;], [&quot;a&quot;, {&quot;c&quot;, &quot;b&quot;}], [{&quot;c&quot;, &quot;b&quot;}, &quot;a&quot;], [&quot;b&quot;, {&quot;a&quot;, &quot;c&quot;}], [{&quot;a&quot;, &quot;c&quot;}, &quot;b&quot;], [&quot;b&quot;, {&quot;c&quot;, &quot;a&quot;}], [{&quot;c&quot;, &quot;a&quot;}, &quot;b&quot;], [&quot;c&quot;, {&quot;a&quot;, &quot;b&quot;}], [{&quot;a&quot;, &quot;b&quot;}, &quot;c&quot;], [&quot;c&quot;, {&quot;b&quot;, &quot;a&quot;}], [{&quot;b&quot;, &quot;a&quot;}, &quot;c&quot;] ]","ref":"Exun.Pattern.html#combin_expand/2","title":"Exun.Pattern.combin_expand/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#concatlist/1","title":"Exun.Pattern.concatlist/1","type":"function"},{"doc":"take a list an generate all possible list varying order of elements list can be of tye [a, [b,c],d] but b and c cannot be lists must produce [ [a,[b,c],d], [a,[c,b],d], [a,d,[b,c]], [a,d,[c,b]], [d,a,[b,c]], [d,a,[c,b]], [[b,c],a,d], [[b,c],d,a], [[c,b],a,d], [[c,b],d,a], ]","ref":"Exun.Pattern.html#expand_order/1","title":"Exun.Pattern.expand_order/1","type":"function"},{"doc":"Extract sublist of l of size sizes extract [1,2,3,4,5],[1,2,2] -&gt; [[1],[2,3],[4,5]]","ref":"Exun.Pattern.html#extract/2","title":"Exun.Pattern.extract/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#listornot/1","title":"Exun.Pattern.listornot/1","type":"function"},{"doc":"","ref":"Exun.Pattern.html#match/5","title":"Exun.Pattern.match/5","type":"function"},{"doc":"Make some expansions in east in order to match complex matching expressions. For example match &quot;ff'x&quot; to &quot;2x^3&quot; will match if it is transformed to &quot;2xx^2&quot; so f=x^2","ref":"Exun.Pattern.html#match_ast/4","title":"Exun.Pattern.match_ast/4","type":"function"},{"doc":"deriv match in two situations: if name is yet in map, its definition must be equal to exp. If not it will match if we can integrate expr; initially we ca use symbolic integration, but if in conditions name is used without deriv, the condition will no be true if we can not integrate it.","ref":"Exun.Pattern.html#mderiv/3","title":"Exun.Pattern.mderiv/3","type":"function"},{"doc":"Match a function definition as matching f(x,y) &lt;-&gt; &quot;xy&quot;, so put in map the match f=xy if f is not yet defined or it is and equals x*y If we use a pattern like f(x) then x must be in the expression expr in any way. If we use f(g(x)) then g(x) must be in the expression also","ref":"Exun.Pattern.html#mfdef/3","title":"Exun.Pattern.mfdef/3","type":"function"},{"doc":"Match integral, only allowed as abstract form &quot;$f,x&quot;","ref":"Exun.Pattern.html#minteg/3","title":"Exun.Pattern.minteg/3","type":"function"},{"doc":"","ref":"Exun.Pattern.html#mklist_byindex/2","title":"Exun.Pattern.mklist_byindex/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#mknumber/2","title":"Exun.Pattern.mknumber/2","type":"function"},{"doc":"","ref":"Exun.Pattern.html#mlist/3","title":"Exun.Pattern.mlist/3","type":"function"},{"doc":"All possible matchings from l2 to l1. l2 must be equal or greater in lenght, if not there is no possible match. Caller must comlpete l2 with 'unity', this is not going to happend here. l1 is abstract, l2 a real expression. # if map holds any definition from l1, match it before generalize; if we can't, return ko # if yes, reduce l2 and l1 for that definitions. We have to substitute map values into l1 # and then perform match # For now, try direct match; sin florituras","ref":"Exun.Pattern.html#mmult/3","title":"Exun.Pattern.mmult/3","type":"function"},{"doc":"General matching function Try to match an abstract expresion agains real expression, for example abstract expression: u(x)*v(x)'x real expression: sin(x)^2match u(x) = sin(x) and v(x)'x= sin(x) so v(x)=-cos(x)u and v will be return in a map: %{&quot;u(x)&quot;=&gt;&quot;sin(x)&quot;, &quot;v(x)&quot;=&gt;&quot;-cos(x)&quot;}return a list of tuples {:ok, matched_defs} or {:ko, matched_defs} matched_defs is a map that holds definitions","ref":"Exun.Pattern.html#mnode/3","title":"Exun.Pattern.mnode/3","type":"function"},{"doc":"","ref":"Exun.Pattern.html#par_inspect/1","title":"Exun.Pattern.par_inspect/1","type":"function"},{"doc":"","ref":"Exun.Pattern.html#permute/1","title":"Exun.Pattern.permute/1","type":"function"},{"doc":"","ref":"Exun.Pattern.html#rcombin/3","title":"Exun.Pattern.rcombin/3","type":"function"},{"doc":"","ref":"Exun.Pattern.html#remove_dups/1","title":"Exun.Pattern.remove_dups/1","type":"function"},{"doc":"","ref":"Exun.Pattern.html#single_expand_order/1","title":"Exun.Pattern.single_expand_order/1","type":"function"},{"doc":"Sets each of size group than sums number Exun.Pattern.sizesets 7,4 -&gt; [1, 1, 4, 1], [1, 1, 3, 2], [1, 2, 3, 1], [1, 2, 2, 2]] If you have a {{:m,op}, lst} and wants to pattern match lst against an abstract sum with 'n' variables, for example match '1+2x+3x^2+6x^3' with an abstract tree like 'a^2+b+c^3' so a=sqrt(3)x, b=1+2x, c=crt(6)x we have to try all possible groupings of the sum expression","ref":"Exun.Pattern.html#sizesets/2","title":"Exun.Pattern.sizesets/2","type":"function"},{"doc":"Split expression in two ast, one of them without vari x These two ast only can be {:m,sum} or {:m,:mult} for now","ref":"Exun.Pattern.html#split/2","title":"Exun.Pattern.split/2","type":"function"},{"doc":"Expand sublists taking one lement from each and building a new list [[a], [b,c]] -&gt; [[a,b],[a,c]] [[a,b]] -&gt; [a,b]","ref":"Exun.Pattern.html#subpermute/1","title":"Exun.Pattern.subpermute/1","type":"function"},{"doc":"Make any possible sets of size n from list without order takeany([],[1,2,3,4],3) -&gt; [[1, 2, 3], [1, 2, 4], [1, 3, 4], [2, 3, 4]]","ref":"Exun.Pattern.html#takeany/3","title":"Exun.Pattern.takeany/3","type":"function"},{"doc":"","ref":"Exun.Pattern.html#transform/2","title":"Exun.Pattern.transform/2","type":"function"},{"doc":"trx1: {{:m,:mult},lst} where k={:elev, {:vari,a},{some}} in list will double matched, original and replacing k with a^(some-remain_lst)a^(remain_lst) in a try to match ff'x &lt;- &quot;2x^3&quot;, so also will try &quot;2x^(3-2)x^2&quot; == &quot;2x*x^2&quot; and then f==x^2","ref":"Exun.Pattern.html#trx1/1","title":"Exun.Pattern.trx1/1","type":"function"},{"doc":"User function, try to match and prints","ref":"Exun.Pattern.html#umatch/4","title":"Exun.Pattern.umatch/4","type":"function"},{"doc":"Find vars of an expression","ref":"Exun.Pattern.html#vars_of_expr/1","title":"Exun.Pattern.vars_of_expr/1","type":"function"},{"doc":"","ref":"Exun.Pattern.html#vars_of_expr/2","title":"Exun.Pattern.vars_of_expr/2","type":"function"},{"doc":"Simplify expressions","ref":"Exun.Simpl.html","title":"Exun.Simpl","type":"module"},{"doc":"","ref":"Exun.Simpl.html#acollect_minus/1","title":"Exun.Simpl.acollect_minus/1","type":"function"},{"doc":"","ref":"Exun.Simpl.html#collect_minus/1","title":"Exun.Simpl.collect_minus/1","type":"function"},{"doc":"Recursively try to simplify expression. Multiple tries are performed. For a more agressive simplify, use Exun.Collect.coll","ref":"Exun.Simpl.html#mkrec/1","title":"Exun.Simpl.mkrec/1","type":"function"},{"doc":"Parses a tree and transform to string in User Readable form","ref":"Exun.UI.html","title":"Exun.UI","type":"module"},{"doc":"Prints in human readable form an AST. Each returns the text converted, the prioriti of the node, a flag indicating if must be included in denominator of a division, and another flag indicatin if must be preceded with a sign - before expression","ref":"Exun.UI.html#show/1","title":"Exun.UI.show/1","type":"function"},{"doc":"Translate tree to human readable math expression: iex(1)&gt; {_tree, _deps} = Exun.parse &quot;4*x^(y+1)/z&quot;,%{&quot;z&quot;=&gt;&quot;y+1&quot;} {{{:m, :mult}, [ {:numb, 4}, {:elev, {:vari, &quot;x&quot;}, {{:m, :suma}, [numb: 1, vari: &quot;y&quot;]}}, {:elev, {:vari, &quot;z&quot;}, {:numb, -1}} ]}, %{{:vari, &quot;z&quot;} =&gt; {{:m, :suma}, [numb: 1, vari: &quot;y&quot;]}}}","ref":"Exun.UI.html#tostr/1","title":"Exun.UI.tostr/1","type":"function"},{"doc":"Handle Units, converts, sum, multiply, transform to SI and factorize","ref":"Exun.Unit.html","title":"Exun.Unit","type":"module"},{"doc":"Convert units, for example iex&gt; import Exun.Unit iex&gt; &quot;120[Km/h]&quot; |&gt; convert(&quot;m/s&quot;) &quot;33.333333333333336[m/s]&quot;","ref":"Exun.Unit.html#convert/3","title":"Exun.Unit.convert/3","type":"function"},{"doc":"Convert first unit to the second unit in convert:u1 = Exun.parse &quot;3[m]&quot; u2 = Exun.parse &quot;1[cm]&quot; Exum.Units.convert(u1,u2,%{}) |&gt; Exum.tostr() &quot;300[cm]&quot;","ref":"Exun.Unit.html#convert_ast/3","title":"Exun.Unit.convert_ast/3","type":"function"},{"doc":"Factorize units, as text:factorize(&quot;2[N]&quot;,&quot;[Kg]&quot;)","ref":"Exun.Unit.html#factorize/3","title":"Exun.Unit.factorize/3","type":"function"},{"doc":"Factorize unit u2 from u1, for example iex(1)&gt; {u1,d} = Exun.parse &quot;1[km*Kg*A/h^2]&quot;, %{} {u2,d} = Exun.parse &quot;1[N]&quot;, %{} factorized = Exun.Unit.factorize(u1,u2,%{}) Exum.Tree.tostr factorized &quot;7.566861148315854e-4[N*A]&quot;","ref":"Exun.Unit.html#factorize_ast/3","title":"Exun.Unit.factorize_ast/3","type":"function"},{"doc":"Shows help about unit Known Units prefixes: E = 1.0e18 G = 1.0e9 K = 1000 M = 1.0e6 P = 1.0e15 T = 1.0e12 a = 1.0e-18 c = 0.01 d = 0.1 f = 1.0e-15 h = 100 m = 0.001 n = 1.0e-9 p = 1.0e-12 u = 1.0e-6Know fundamental units: A = true K = true cd = true g = true m = true mol = true s = trueKnow conversions, you can add more via 'context' lb = 453.59237[g] torr = 133.322368421[Pa] vara = 83.6[cm] W = 1[Kg*m^2/s^3] dyn = 0.00001[Kg*m/s^2] ozt = 31.1034768[g] pie = 30.48[cm] min = 60[s] ozUK = 28.413075[ml] hp = 745.699871582[W] yr = 31556925.9747[s] acre = 4046.87260987[m^2] cal = 4.1868[J] in = 2.54[cm] rd = 5.02921005842[m] galUK = 4.546092[l] J = 1[Kg*m^2/s^2] pdl = 0.1382549544376[N] Btu = 1055.05585262[J] therm = 105506000[J] u = 1.6605402e-24[g] h = 3600[s] qt = 0.946352946[l] gf = 0.00980665[N] ft = 0.3048[m] ozfl = 2.95735295625e-2[l] lbf = 4.44822161526[N] Pa = 1[Kg/m/s^2] cu = 0.2365882365[l] bu = 35239.07[ml] bar = 100000[Pa] l = 100[cm^3] ton = 907.18474[Kg] tonUK = 1016.0469088[Kg] bbl = 158987.294928[ml] chain = 20.1168402337[m] pt = 0.473176473[l] t = 1000[Kg] inH2O = 248.84[Pa] pk = 8809.7675[ml] inHg = 3386.38815789[Pa] ct = 0.2[g] mmHg = 1[torr] N = 101.9716[g*m/s^2] oz = 28.349523125[g] galC = 4.54609[l] pc = 3.08567818585e16[m] mi = 1609.344[m] eV = 1.60217733e-19[J] kip = 4448.22161526[N] Hz = 1[1/s] yd = 91.44[cm] CV = 1[hp] slug = 14.5939029372[Kg] fath = 1.82880365761[m] arroba = 25[lb] d = 86400[s] gal = 3.785411784[l] angstrom = 1.0e-10[m] au = 149597900000[m] atm = 101325[Pa] lyr = 9.46052840488e15[m] tbsp = 14.78676447813[ml] tsp = 4.92892159375[ml] erg = 0.0000001[J] a = 100[m^2] grain = 0.06479891[g] lbt = 373.2417216[g] fbm = 2359.737216[ml] psi = 6894.75729317[Pa]","ref":"Exun.Unit.html#help/0","title":"Exun.Unit.help/0","type":"function"},{"doc":"Sum or Rest of two units","ref":"Exun.Unit.html#sum/3","title":"Exun.Unit.sum/3","type":"function"},{"doc":"Converts unit to International System","ref":"Exun.Unit.html#toSI/1","title":"Exun.Unit.toSI/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Debg.html","title":"Mix.Tasks.Debg","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Debg.html#run/1","title":"Mix.Tasks.Debg.run/1","type":"function"}]